# Usercentrics CMP

## CONTENTS OF THIS FILE

 * Introduction
 * Installation
 * Configuration
 * Usercentrics Data Processing Service (DPS)

## INTRODUCTION

This module implements the Consent Management Platform (CMP) from usercentrics.com.

Users of the website must select which data processing services are to be used before loading from external sources.

## HOW IT WORKS

Usercentrics offers a service for managing consents, e.g. for the use of cookies or 3rd party services.

To make this work, the script tags must be customised (see Usercentrics documentation). The module makes these adjustments if the appropriate Usercentrics Data Processing Services are configured in Drupal.


## INSTALLATION

Install as you would normally install a contributed Drupal module.

See https://www.drupal.org/docs/extending-drupal/installing-modules for further
information.

No other libraries are required.

## CONFIGURATION

Visit /admin/config/user-interface/usercentrics and enter your usercentrics ID and enable the service.

Smart Data Protection (SDP) can be activated in a separate tab.

You can display an icon at the bottom of the screen that users can use to access their consent settings at any time. You can also configure your own logo path for this button.

In the advanced settings tab, debugging settings can be configured to support the creation of own Usercentrics Data Processing Services. Usercentrics can also be deactivated for admin paths (default) or users with the admin role.

## USERCENTRICS DATA PROCESSING SERVICES (DPS)

To make the necessary changes to the script integrations the corresponding DPSs must be configured and activated. The module provides apps for Matomo, Google Analytics and Google Tag Manager. You can enable them on /admin/config/user-interface/usercentrics/apps. All DPSs are disabled by default.

- If you use Data Processing Service (DPS) Google Analytics 4 with the Google Tags module for Drupal you can use the predefined "Google Analytics 4" DPS - you cannot use the predefined DPSs "Google Analytics 4" and "Google Tags" at the same time.
- The Drupal module Google Analytics is deprecated and the successor is the module Google Tag 2.0+.
- The Drupal module Google Analytics GA4 cannot be used with this Usercentrics module, as it works with inline-themes and therefore bypasses Drupal logic.

You can create your own apps for the scripts you use.

The focus is on the information that the module can use to recognise and adapt the associated scripts. This can be:

* a library name (see mymodule.libraries.yml)
* the script name or a part of it (see e.g. in the source representation of your website)
* the machine name of an attachment (see source code of your module).

Debug mode can be activated to help with the creation. All libraries, scripts and attachments found are then documented in the watchdog (severity debug); if adjustments are made, this is logged with severity info.

Please check the correct implementation (e.g. with Firefox Inspector or Lighthouse Project). Modules may change their code or configuration. Some Modules may implement external source in other ways (e.g. iframe) so you have to decide if this comply with your needs.
